<?php
/**
  * Ceneo class, ceneo.php
  * Ceneo
  * @category modules
  *
  * @author Outdorzy.pl <l.golonka@outdoorzy.pl>
  * @copyright Outdoorzy.pl
  * @license http://www.opensource.org/licenses/osl-3.0.php Open-source licence 3.0
  * @version 0.1
  *
  */
class Ceneo extends Module
{
    private $_html = '';
    private $_directory;
    private $_filename;
    private $_filename_http;
    private $_ajax_gateway;
    private $_postErrors = array();

    function __construct()
    {
        $this->name = 'ceneo';
        $this->tab = 'Tools';
        $this->version = 0.1;

        $this->_directory = dirname(__FILE__).'/../../';
        $this->_filename = $this->_directory.'ceneo.xml';
        $this->_filename_http = 'http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'ceneo.xml';
        $this->_ajax_gateway = '../modules/ceneo/get_categories.php';

        parent::__construct();
		
        /* The parent construct is required for translations */
		  $this->page = basename(__FILE__, '.php');
        $this->displayName = $this->l('Prównywarka ceneo.pl');
        $this->description = $this->l('Wygeneruj plik xml dla porównywarki ceneo.pl');
    }

    function uninstall()
    {
        @unlink($this->_filename);
        parent::uninstall();
		
		// Hack for 'gsitemap' to uninstall it correctly
		Db::getInstance()->Execute('
				DELETE FROM `'._DB_PREFIX_.'module`
				WHERE `id_module` = '.intval($this->id));
    }
    private function _postValidation()
    {
		@unlink($this->_filename);
		$fp = fopen($this->_filename, 'w');
		fclose($fp);
		if (!file_exists($this->_filename))
			$this->_postErrors[] = $this->l('Nie mogę zapisać pliku').' '.realpath(dirname(__FILE__.'/../..')).$this->l('ceneo.xml.');
    }

    private function _postProcess()
    {	
		if(isset($_POST['btnSubmit'])){	
	     	$map_data = array();
    		if(file_exists(dirname(__FILE__).'/map.data')){
	    		$data = file_get_contents(dirname(__FILE__).'/map.data');
	    		eval($data);
	    	}    
		  $link = new Link();
        $fp = fopen($this->_filename, 'w');
        $xml = new DOMDocument();
        $xml->loadXML('<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE pasaz:Envelope SYSTEM "loadOffers.dtd">
				<pasaz:Envelope xmlns:pasaz="http://schemas.xmlsoap.org/soap/envelope/">
  					<pasaz:Body>
    				<loadOffers xmlns="urn:ExportB2B"><offers></offers>
					</loadOffers>
					</pasaz:Body>
					</pasaz:Envelope>');        
			$offers = $xml->getElementsByTagName('offers');
			$offers = $offers->item(0);
			$sql = '
			SELECT p.id_product, pl.link_rewrite, DATE_FORMAT(p.date_add, \'%Y-%m-%d\') AS date_add, pl.name AS p_name, pl.description_short p_desc,
			m.name AS m_name, id_image, cl.name as c_name
			FROM '._DB_PREFIX_.'product p
			LEFT JOIN '._DB_PREFIX_.'product_lang pl ON (p.id_product = pl.id_product)
			LEFT JOIN '._DB_PREFIX_.'manufacturer m ON (m.id_manufacturer = p.id_manufacturer)
			LEFT JOIN '._DB_PREFIX_.'image i ON (p.id_product = i.id_product AND i.cover = 1)
			INNER JOIN '._DB_PREFIX_.'category_product cp ON (cp.id_product = p.id_product)
			INNER JOIN '._DB_PREFIX_.'category cat on (cat.id_category = cp.id_category AND cat.id_category <> 1)
			INNER JOIN '._DB_PREFIX_.'category_lang cl ON (cl.id_category = cat.id_category)	
			WHERE p.active = 1
			ORDER BY id_product								 					
			';

	      $products = Db::getInstance()->ExecuteS($sql);						
				
	        foreach($products as $product)
	        {
	            $mdc = md5($product['c_name']);	            
	            if($map_data[$mdc] == '')continue;
	            $offer = $xml->createElement('offer');
	            $offers->appendChild($offer);
	            
	           	$id = $xml->createElement('id',$product['id_product']);	            
	            $offer->appendChild($id);
	            
	            $name_txt = $xml->createCDATASection($product['p_name']);
	            $name = $xml->createElement('name');
	            $name->appendChild($name_txt);
	            $offer->appendChild($name);
	            
	            $price = $xml->createElement('price',Product::getPriceStatic($product['id_product']));	          
	            $offer->appendChild($price);
	            	           	
	            $url = $xml->createElement('url','http://'.$_SERVER['HTTP_HOST'].htmlspecialchars($link->getProductLink($product['id_product'], $product['link_rewrite'])));
	            $offer->appendChild($url);
	            
					$category_txt = $xml->createCDATASection(isset($map_data[$mdc])?$map_data[$mdc]:$product['c_name']);
	            $categoryId = $xml->createElement('categoryId');
	            $categoryId->appendChild($category_txt);
	            $offer->appendChild($categoryId);
	            
	           	$desc_txt = $xml->createCDATASection(strip_tags($product['p_desc']));
	            $desc = $xml->createElement('description');
	            $desc->appendChild($desc_txt);
	            $offer->appendChild($desc);
	            
	            if($product['id_image']>0){	            		           			            
		            $image = $xml->createElement('image','http://'.$_SERVER['HTTP_HOST'].__PS_BASE_URI__.'img/p/'.htmlspecialchars($product['id_product'].'-'.$product['id_image'].'.jpg'));
		            $offer->appendChild($image);
					}
	            	           
	        }

	        $xmlString = $xml->saveXML();
	        fwrite($fp, $xmlString, strlen($xmlString));
	        fclose($fp);
	
	        $res = file_exists($this->_filename);
	        $this->_html .= '<h3 class="'. ($res ? 'conf confirm' : 'alert error') .'" style="margin-bottom: 20px">';
	        $this->_html .= $res ? $this->l('Plik xml produktów wygenerowano poprawnie') : $this->l('Wystąpił błąd podczas tworzenia pliku xml dla ceneo.pl');
	        $this->_html .= '</h3>';
		}elseif(isset($_POST['btnMap'])){
			$save_data = '';
			foreach($_POST as $key => $input){
				if('btnMap'!=$key){
					$save_data .= '$map_data[\''.$key.'\'] = "'.$input.'";'; 
				}
			}		
			$fh = fopen(dirname(__FILE__).'/map.data','w+');					
			fwrite($fh,$save_data);
			fclose($fh);
			$res = file_exists(dirname(__FILE__).'/map.data');
			$this->_html .= '<h3 class="'. ($res ? 'conf confirm' : 'alert error') .'" style="margin-bottom: 20px">';
	      $this->_html .= $res ? $this->l('Mapowanie zapisano !') : $this->l('Wystąpił błąd podczas tworzenia pliku mapowania ceneo.pl');
	      $this->_html .= '</h3>';
		}
    }

    private function _displayInfo()
    {
        if (file_exists($this->_filename))
        {			
            $fp = fopen($this->_filename, 'r');
            $fstat = fstat($fp);
            fclose($fp);
            $xml = new DOMDocument();
            $xml->load($this->_filename);
            $prods = $xml->getElementsByTagName('id');
            $nbPages = $prods->length;

            $this->_html .= '<p>'.$this->l('Plik dla porównywarki ceneo.pl jest on-line pod adresem:').'<br />
            <a href="'.$this->_filename_http.'"><b>'.$this->_filename_http.'</b></a></p><br />';

            //setlocale(LC_ALL, 'fr_FR@euro', 'pl_PL', 'pl');
            $this->_html .= $this->l('Ostatnia zmiana:').' <b>'.date ("F d Y H:i:s.", filemtime($this->_filename)).'</b><br />';
            $this->_html .= $this->l('Rozmiar pliku:').' <b>'.number_format(($fstat['size']*.000001), 3).' MB</b><br />';
            $this->_html .= $this->l('Zaindeksowanych produktów:').' <b>'.$nbPages.'</b><br />Gdy produkt jest przydzielony do więcej niż 1 kategorii może się powtarzać.<br /><br />';
        }
    }

    private function _displayForm()
    {
        $this->_html .=
        '<b>Najpierw dokonaj mapowania swoich kategorii do kategorii ceneo.pl. Później wygeneruj plik XML !</b><br /><br />'.
        '<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<input name="btnSubmit" class="button" value="'.((!file_exists($this->_filename)) ? $this->l('Generuj plik xml dla ceneo.pl') : $this->l('Aktualizuj plik xml dla ceneo.pl')).'" type="submit" />
        </form><br /><br />';
        $this->_html .='<h3>Mapuj kategorie ceneo.pl z kategoriami twojego sklepu (kliknij w pole tekstowe)</h3>';
        $this->_html .= $this->_getCeneoCategories();   
        $this->_html .= $this->_getCategories();             
    }
    
    function getContent()
    {
        $this->_html .= '<h2>'.$this->l('Integracja z porównywarką ceneo.pl').'</h2>';
        
        if (!empty($_POST))
        {
            $this->_postValidation();
            if (!count($this->_postErrors))
                $this->_postProcess();
            else
                foreach ($this->_postErrors AS $err)
                    $this->_html .= '<div class="error">'.$err.'</div>';
        }
        else
            $this->_html .= '<br />';

        $this->_displayInfo();
        $this->_displayForm();

        return $this->_html;
    }
    
    
    function _getCategories(){
    	global $cookie, $smarty;  
    	$map_data = array();
    	if(file_exists(dirname(__FILE__).'/map.data')){
    		$data = file_get_contents(dirname(__FILE__).'/map.data');
    		eval($data);
    	}    	  	   
    	$sql = 'SELECT name,id_category  FROM '._DB_PREFIX_.'category_lang WHERE id_lang ='.intval($cookie->id_lang);    	
    	$categories = Db::getInstance()->ExecuteS($sql);
    	$html = '<form method="post"><table>';
    	$id = 1;
    	foreach($categories as $category){
    		$mdc = md5($category['name']);
    		$html .= '<tr><td>'.Tools::getPath($category['id_category']).$category['name'].' = </td><td><input id="i'.$id.'" name="'.$mdc.'" size="50" onClick="javascript:showcc(this.id)" value="'.(isset($map_data[$mdc])?$map_data[$mdc]:'').'"/><a name="'.$id.'"> </a></td></tr>';
    		$id++;
    	}
    	$html .= '</table>';
    	$html .= '<input name="btnMap" class="button" value="'.($this->l('Zapisz mapowanie kategorii')).'" type="submit" /></form><br />';
    	return $html;
    }
    
    
    function _getCeneoCategories(){
    	$html .= '<script src="../js/jquery/jquery.pack.js" ></script>';    	
    	$html .= '<div id="ceneo_cat" style="background-color: white;overflow:scroll;overflow-x:scrool;overflow-y:scroll;width:600px;height:100px;border:1px solid black;visibility:hidden;position:absolute;"><div style="text-align:center;">Czekaj ładuje kategorie ceneo ...</div></div>';
    	$html .='<script>
		var current_input = null;
		var current_x = 0;
		var current_y = 0;
		document.body.onclick = function getxy(e){
				var posx = 0;
				var posy = 0;
				if (!e) var e = window.event;
				if (e.pageX || e.pageY) 	{
					posx = e.pageX;
					posy = e.pageY;
				}
				else if (e.clientX || e.clientY) 	{
					posx = e.clientX + document.body.scrollLeft
						+ document.documentElement.scrollLeft;
					posy = e.clientY + document.body.scrollTop
						+ document.documentElement.scrollTop;
				};
			var ceneo = document.getElementById(\'ceneo_cat\');
			
			if(1==ceneo.show){
				ceneo.style.top = parseInt(posy)+"px";
				ceneo.style.left = parseInt(posx)+"px";
				ceneo.show = 2;
			}	
			current_x = posx;
			current_y = posy;
	
		}
  
		function showcc(inp){
			var ceneo = document.getElementById(\'ceneo_cat\');
			ceneo.style.visibility = \'\';
			ceneo.show = 1;
			current_input = inp;
			$(\'#ceneo_cat\').load(\''.$this->_ajax_gateway.'\');
		}	

		function copyCat(a){			
			var ceneo = document.getElementById(\'ceneo_cat\');
			ceneo.style.visibility = \'hidden\';
			ceneo.show = 0;
			var input = document.getElementById(current_input);
			input.value = a.innerText?a.innerText:a.text;
			window.scrollTo(current_x,current_y);
		}

		</script>';
    	return $html;
    }
    
    static function xmlCatCeneo(){    	
    	$html = '';
		$xml = simplexml_load_file('http://api.ceneo.pl/Kategorie/dane.xml');		
    	foreach($xml->children() as $item){    		
			$html .= Ceneo::reccuringC($item,$item->Name);  		
    	}
    	return $html;    	
    }
    
    static function reccuringC($node,$path){	
    	$html ='';
    	if(false == strpos($path,'/')){
    		$html = '<a href="#" onClick="javascript:copyCat(this)" style="color:blue;text-decoration:underline;">';
    	}else{ 
    		$html = '<a href="#" onClick="javascript:copyCat(this)" style="color:blue;text-decoration:underline;">'.$path;
    	}		
    	if($node->Subcategories){    
    		foreach($node->Subcategories->children() as $sub){    			    		
				$html .= Ceneo::reccuringC($sub,$path.'/'.$sub->Name);
    		}    		
			
    	}else{
    		$html .= '</a><br />';
    	}	        	 		
 		return $html;
    }
}


?>
